#!/system/bin/sh

TAG="AudioHwInit"
AUDIO_ADC_REF=/vendor/device/jack_adc_ref.conf

if [ ! -e $AUDIO_ADC_REF ]; then
  dp_nvm_str=$(ipc2dp nvm get HS_HW-Config.uiDetectLevel full | busybox grep HS_HW-Config.uiDetectLevel)
  [ ! $? = 0 ] && dp_nvm_str=$(ipc2dp nvm get HS_HW-Config.uiDetectLevel full | busybox grep HS_HW-Config.uiDetectLevel)

  if [ $? = 0 ]; then
    log -t $TAG "Value from DP = $dp_nvm_str"	
    dp_nvm_ref=$( echo $dp_nvm_str | busybox cut -d "=" -f 2)
    if [ $dp_nvm_ref -ge 2000 -a $dp_nvm_ref -le 2500 ]; then
      mkdir -p /vendor/device
      chmod 755 /vendor/device
      echo $dp_nvm_ref > $AUDIO_ADC_REF
      chmod 644 $AUDIO_ADC_REF
      log -t $TAG "Write value $dp_nvm_ref -> $AUDIO_ADC_REF"
    fi
  fi
fi


if [ ! -e /vendor/device/hwrun.conf ]; then
  OTP_HW_RUN=$(busybox printf "0x%08x" $(cat /sys/fsl_otp/HW_OCOTP_GP1))
  OTP_MAJOR=$(echo $OTP_HW_RUN | busybox cut -b 4)
  if [ ! $OTP_MAJOR = 0 ]; then
    mkdir -p /vendor/device
    chmod 755 /vendor/device/
    echo $OTP_MAJOR > /vendor/device/hwrun.conf
    chmod 644 /vendor/device/hwrun.conf
    log -t $TAG "Use OTP settings" $OTP_MAJOR
  fi
fi

if [ -e /vendor/device/hwrun.conf ]; then
  HWRUN=$(cat /vendor/device/hwrun.conf)
else
  HWRUN=5 #default HW Run
fi


echo "Audio init, current hardware run is" $HWRUN
log -t $TAG "Current hardware run is" $HWRUN

while [ $HWRUN -ne 0 ]; do
  AUDIO_JACK_CONF=/system/etc/audio_jack_run_$HWRUN.conf
  if [ -e $AUDIO_JACK_CONF ]; then 
      echo "Configure jack ... $AUDIO_JACK_CONF"
      cat $AUDIO_JACK_CONF > /sys/devices/platform/imx-wm8750.0/switches/jack_cfg
      if [ -e $AUDIO_ADC_REF ]; then
        echo "Configure adc reference ... $AUDIO_ADC_REF"
        cat $AUDIO_ADC_REF > /sys/devices/platform/imx-wm8750.0/switches/jack_adc_ref
      else
        log -t $TAG "$AUDIO_ADC_REF not found"
      fi
      break
  else
    log -t $TAG "$AUDIO_JACK_CONF not found"
    let HWRUN=$HWRUN-1
  fi 
done 

echo 10 > /sys/devices/platform/soc-audio.7/HiFi/pmdown_time
echo 10 > /sys/module/snd_soc_imx_wm8750/parameters/caps_charge
